/*!
    * FastSpring fullcart.js
*/
function addRedirect(product, location) {
	fastspring.builder.add(product, function(data){
  		window.location.href=location; // set this to the cart page full or relative URL
	});	
}

function applycoupon() {
    var couponid= document.getElementById('couponcode').value;
    fastspring.builder.promo(couponid);
}

function markupHelpersCallback() {
    Handlebars.registerHelper('iff', function(lvalue, operator, rvalue, options) {
        //if (window.hasOwnProperty(rvalue)) rvalue = window[rvalue];
        var functions = {
            '==':       function(l,r) { return l == r; },
            '===':      function(l,r) { return l === r; },
            '!=':       function(l,r) { return l != r; },
            '<':        function(l,r) { return l < r; },
            '>':        function(l,r) { return l > r; },
            '<=':       function(l,r) { return l <= r; },
            '>=':       function(l,r) { return l >= r; },
            'typeof':   function(l,r) { return typeof l === r; }
        };
        if (!functions.hasOwnProperty(operator)){
            throw new Error("Handlerbars Helper 'iff' doesn't know the operator " + operator);
        }
        var result = functions[operator](lvalue,rvalue);
        if( result ) {
            return options.fn(this);
        } else {
            return options.inverse(this);
        }
    });
    Handlebars.registerPartial("pricing", document.getElementById('pricing-partial').innerHTML);
    Handlebars.registerPartial("quantity", document.getElementById('quantity-partial').innerHTML);
    Handlebars.registerPartial("volume-discount", document.getElementById('volume-discount').innerHTML);
    Handlebars.registerPartial("xsellupsell", document.getElementById('xsellupsell').innerHTML);
    Handlebars.registerPartial("singlechoice", document.getElementById('singlechoice').innerHTML);
    Handlebars.registerPartial("multichoice", document.getElementById('multichoice').innerHTML);
}

function beforeRequestsCallbackFunction() {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.display = "block";
}

function afterMarkupCallbackFunction() {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
}

function popupClosed(data) {
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
    if (data) {
        fastspring.builder.reset();
        /*If you want to redirect you can do the following*/
        /*window.location.replace("https://myDomain.com/?orderId=" + data.reference);*/
    }
}

/*If using Google Analytics, you can use the following function to decorate the links*/
function decorateCallback(url) {
    var linkerParam = null;
    if ( ga && typeof ga === 'function') {
        ga(function() {
            var trackers = ga.getAll();
            linkerParam = trackers[0].get('linkerParam');
        });
    }
    return (linkerParam ? url + '?' + linkerParam : url);
}

function errorCallback(code, string) {
    console.log('errorcallback');
    var fs_spinner=document.getElementById("fs_spinner");
    fs_spinner.style.animationName="fs_revfadeIn";
    setTimeout(function(){
        fs_spinner.style.animationName = "fs_fadeIn";
        fs_spinner.style.display = "none";
    },450);
    var fs_error=document.getElementById("fs_error");
    var fs_error_msg=document.getElementById("fs_error_msg");
    fs_error.style.display = "block";
    fs_error.style.animationName = "fs_mod_animatetop";
    fs_error_msg.innerHTML = "Error: " + code + " - " + string;
    setTimeout(function(){
        fs_error.style.animationName = "fs_mod_revanimatetop";
        setTimeout(function(){
            fs_error.style.display = "none";
        }, 400)
    },5000);
}

function dataCallback(data) {
    if(data.messages[0]) {
        var fs_error=document.getElementById("fs_error");
        var fs_error_msg=document.getElementById("fs_error_msg");
        fs_error.style.display = "block";
        fs_error.style.animationName = "fs_mod_animatetop";
        fs_error_msg.innerHTML = data.messages[0].phrase;
        setTimeout(function(){
            fs_error.style.animationName = "fs_mod_revanimatetop";
            setTimeout(function(){
                fs_error.style.display = "none";
            }, 400)
        },5000);
    }
}